package com.xkrs.controller;

import com.xkrs.common.encapsulation.PromptMessageEnum;
import com.xkrs.dao.FirePointOrdinaryDao;
import com.xkrs.dao.FirePointPreciseDao;
import com.xkrs.dao.StreetDao;
import com.xkrs.dao.SysUserDao;
import com.xkrs.helper.FirePointSubscribeManager;
import com.xkrs.model.entity.FirePointOrdinaryEntity;
import com.xkrs.model.qo.AllFirePointQo;
import com.xkrs.service.DispatchFirePointService;
import com.xkrs.service.impl.FirePointServiceImpl;
import org.apache.hc.core5.util.TextUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import static com.xkrs.common.encapsulation.OutputEncapsulation.outputEncapsulationObject;

@RestController
public class DispatchFirePointController {

    public static Logger log = LoggerFactory.getLogger(FirePointServiceImpl.class);
    @Resource
    private SysUserDao sysUserDao;
    @Resource
    private DispatchFirePointService firePointService;
    @Resource
    private FirePointSubscribeManager firePointSubscribeManager;
    @Resource
    private FirePointOrdinaryDao firePointOrdinaryDao;
    @Resource
    private FirePointPreciseDao firePointPreciseDao;
    @Resource
    private StreetDao streetDao;
    private final Locale locale = LocaleContextHolder.getLocale();

    @GetMapping("/debug")
    public String debug() {

//        List<SysUserEntity> sysUserEntityList = sysUserDao.findAll();
//        for (SysUserEntity sysUserEntity : sysUserEntityList) {
//            String addTime = sysUserEntity.getAddTime();
//            String vipTimeRangeJson = sysUserEntity.getVipTimeRangeJson();
//            if (!DateTimeUtil.isValidDateTime(addTime)) {
//                return sysUserEntity.getUserName();
//            }
//            if (!DateTimeUtil.isValidDateTime(vipTimeRangeJson)) {
//                return sysUserEntity.getUserName();
//            }
//            VipTimeRangeBean.VipTimeRangeItemBean vipTimeRangeItemBean = new VipTimeRangeBean.VipTimeRangeItemBean();
//            vipTimeRangeItemBean.setStartTime(addTime);
//            vipTimeRangeItemBean.setEndTime(vipTimeRangeJson);
//            List<VipTimeRangeBean.VipTimeRangeItemBean> list = new ArrayList<>();
//            list.add(vipTimeRangeItemBean);
//            VipTimeRangeBean vipTimeRangeBean = new VipTimeRangeBean();
//            vipTimeRangeBean.setList(list);
//            String serialize = JsonUtils.<VipTimeRangeBean>serialize(vipTimeRangeBean);
//            System.out.println("serialize = " + serialize);
//            sysUserEntity.setVipTimeRangeJson(serialize);
//            sysUserDao.save(sysUserEntity);
//        }

        List<Map<String, String>> maps = streetDao.selectProCityPair();
        List<FirePointOrdinaryEntity> firePointOrdinaryEntityList = firePointOrdinaryDao.findAll();
        List<String> errorList = new ArrayList<>();
        for (FirePointOrdinaryEntity firePointOrdinaryEntity : firePointOrdinaryEntityList) {
            String countyCode = firePointOrdinaryEntity.getCountyCode();
            String proCode = countyCode.substring(0, 2) + "0000";
            firePointOrdinaryEntity.setProCode(proCode);
            firePointOrdinaryEntity.setProName(obtainProName(maps, proCode));
            String cityCode = countyCode.substring(0, 4) + "00";
            firePointOrdinaryEntity.setCityCode(cityCode);
            firePointOrdinaryEntity.setCityName(obtainCityName(maps, cityCode));
            if (TextUtils.isEmpty(firePointOrdinaryEntity.getCountyCode()) || TextUtils.isEmpty(firePointOrdinaryEntity.getCountyName()) || TextUtils.isEmpty(firePointOrdinaryEntity.getCityCode()) || TextUtils.isEmpty(firePointOrdinaryEntity.getCityName()) || TextUtils.isEmpty(firePointOrdinaryEntity.getProCode()) || TextUtils.isEmpty(firePointOrdinaryEntity.getProName())) {
                errorList.add(firePointOrdinaryEntity.getFireCode());
            }
        }
        firePointOrdinaryDao.saveAll(firePointOrdinaryEntityList);
        return outputEncapsulationObject(PromptMessageEnum.SUCCESS, errorList, locale);
    }

    private String obtainProName(List<Map<String, String>> maps, String proCode) {
        for (Map<String, String> map : maps) {
            if (map.get("pro_code").equals(proCode)) {
                return map.get("pro_name");
            }
        }
        return null;
    }

    private String obtainCityName(List<Map<String, String>> maps, String cityCode) {
        for (Map<String, String> map : maps) {
            if (map.get("city_code").equals(cityCode)) {
                return map.get("city_name");
            }
        }
        return null;
    }

    @GetMapping("/autoSync")
    public String autoSync() {
        return firePointSubscribeManager.autoSync();
    }

    /**
     * 普通渠道推送火点到秸秆系统
     */
//    @PostMapping("/insertFirePointChannelOrdinary")
    @PostMapping("/insertFirePoint")
    public String insertFirePointChannelOrdinary(@RequestBody AllFirePointQo firePointQo) {
        return firePointService.insertFirePointChannelOrdinary(firePointQo);
    }

    /**
     * 精准渠道推送火点到秸秆系统
     */
    @PostMapping("/insertFirePointChannelPrecise")
    public String insertFirePointChannelPrecise(@RequestBody AllFirePointQo firePointQo) {
        return firePointService.insertFirePointChannelPrecise(firePointQo);
    }

}
